import { __assign, __rest } from "tslib";
import { faPlus } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import classNames from "classnames";
import React from "react";
import { useControll } from "utils-hooks";
import { getLocal } from "./local";
import Upload from "./Upload";
import UploadFrame from "./UploadFrame";
import { isImageUrl } from "./utils";
var UploadButton = React.forwardRef(function (props, ref) {
    var _a = props.prefixCls, prefixCls = _a === void 0 ? "upload-button" : _a, className = props.className, style = props.style, _b = props.title, title = _b === void 0 ? getLocal().Upload.title : _b, custBtn = props.custBtn, children = props.children, onChange = props.onChange, onStart = props.onStart, onSuccess = props.onSuccess, onError = props.onError, onProgress = props.onProgress, onRemove = props.onRemove, onView = props.onView, _c = props.btnMode, btnMode = _c === void 0 ? false : _c, rest = __rest(props, ["prefixCls", "className", "style", "title", "custBtn", "children", "onChange", "onStart", "onSuccess", "onError", "onProgress", "onRemove", "onView", "btnMode"]);
    var _d = useControll(props, "value", "defaultValue", { status: "ready" }), result = _d[0], setResult = _d[1], isControll = _d[2];
    if (!result) {
        result = { status: "ready" };
    }
    function change(state) {
        if (!isControll) {
            setResult(state);
        }
        if (onChange) {
            onChange(state);
        }
    }
    function onStartHandle(file) {
        if (!btnMode) {
            change({
                status: "uploading",
                file: file,
                thumbnail: URL.createObjectURL(file),
                percent: 0,
                isImg: isImageUrl(file.name),
            });
        }
        if (onStart) {
            onStart(file);
        }
    }
    function onSuccessHandle(file, response, xhr) {
        if (!btnMode) {
            change({ file: file, thumbnail: URL.createObjectURL(file), status: "success", percent: 100, response: response, isImg: isImageUrl(file.name) });
        }
        if (onSuccess) {
            onSuccess(file, response, xhr);
        }
    }
    function onErrorHandle(file, response, xhr) {
        if (!btnMode) {
            change({ file: file, thumbnail: URL.createObjectURL(file), status: "error", percent: 100, response: response, isImg: isImageUrl(file.name) });
        }
        if (onError) {
            onError(file, response, xhr);
        }
    }
    function onProgressHandle(file, percent, event) {
        if (!btnMode) {
            change({ file: file, thumbnail: URL.createObjectURL(file), status: "uploading", percent: percent, isImg: isImageUrl(file.name) });
        }
        if (onProgress) {
            onProgress(file, percent, event);
        }
    }
    function onRemoveHandle(result) {
        if (!btnMode) {
            change({
                status: "ready",
            });
        }
        if (onRemove) {
            onRemove(result);
        }
    }
    return (React.createElement("div", { className: classNames(prefixCls, className), style: style, ref: ref },
        result.status === "ready" ? (React.createElement(Upload, __assign({ className: "upload-button-wrapper" }, rest, { onStart: onStartHandle, onSuccess: onSuccessHandle, onError: onErrorHandle, onProgress: onProgressHandle }), custBtn || (React.createElement("div", { className: prefixCls + "-inner" },
            React.createElement("div", null,
                React.createElement("p", { className: "upload-icon" },
                    React.createElement(FontAwesomeIcon, { icon: faPlus })),
                React.createElement("p", { className: "upload-title" }, title)))))) : (React.createElement(UploadFrame, { result: result, disabledUpload: props.disabled, icons: props.icons, onView: onView, onRemove: onRemoveHandle })),
        React.createElement("div", null, children)));
});
export default React.memo(UploadButton);
//# sourceMappingURL=UploadButton.js.map