import { faEye, faFileUpload, faTrashAlt } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import classNames from "classnames";
import React from "react";
import { getLocal } from "./local";
function UploadFrame(props) {
    var _a = props.prefixCls, prefixCls = _a === void 0 ? "upload-frame" : _a, className = props.className, style = props.style, _b = props.result, result = _b === void 0 ? {} : _b, icons = props.icons, onView = props.onView, onRemove = props.onRemove, disabledUpload = props.disabledUpload, list = props.list, index = props.index;
    var _c = result.status, status = _c === void 0 ? "success" : _c, _d = result.percent, percent = _d === void 0 ? 0 : _d, desc = result.desc, _e = result.isImg, isImg = _e === void 0 ? true : _e;
    function progress() {
        return (React.createElement("div", { className: "progress-position" },
            React.createElement("div", { className: "progress-outer" },
                React.createElement("div", { className: "progress-inner" },
                    React.createElement("div", { className: "progress-bg", style: { width: percent + "%" } })))));
    }
    function statusText() {
        var LocalStatus = getLocal().Upload.status;
        switch (status) {
            case "error":
                return LocalStatus.error;
            case "success":
                return LocalStatus.success;
            case "uploading":
                return LocalStatus.uploading;
            default:
                return LocalStatus.ready;
        }
    }
    return (React.createElement("div", { className: classNames(prefixCls, className, prefixCls + "-status-" + status), style: style },
        !disabledUpload && React.createElement("div", { className: prefixCls + "_badge" }, statusText()),
        React.createElement("div", { className: prefixCls + "_wrapper" },
            React.createElement("div", { className: prefixCls + "_info" }, isImg ? (React.createElement("img", { className: prefixCls + "_thumbnail", src: result.thumbnail })) : (React.createElement("span", { className: prefixCls + "_thumbnail file-thumbnail" },
                React.createElement(FontAwesomeIcon, { icon: faFileUpload })))),
            status === "uploading" ? (progress()) : (React.createElement("div", { className: prefixCls + "_actions" }, icons ? (icons(result, onView, onRemove)) : (React.createElement(React.Fragment, null,
                status === "success" && (React.createElement("span", { onClick: function () {
                        if (onView) {
                            onView(result, index, list);
                        }
                    } },
                    React.createElement(FontAwesomeIcon, { title: getLocal().Upload.preview, className: prefixCls + "_action", icon: faEye }))),
                !disabledUpload && (React.createElement("span", { onClick: function () {
                        if (onRemove) {
                            onRemove(result, index, list);
                        }
                    } },
                    React.createElement(FontAwesomeIcon, { title: getLocal().Upload.delete, className: prefixCls + "_action", icon: faTrashAlt })))))))),
        desc && React.createElement("div", { className: prefixCls + "_text" }, desc)));
}
export default React.memo(UploadFrame);
//# sourceMappingURL=UploadFrame.js.map