function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
}
/**
 * 判断 accept 是否匹配
 */
export function attrAccept(file, acceptedFiles) {
    if (file && acceptedFiles) {
        var acceptedFilesArray = Array.isArray(acceptedFiles) ? acceptedFiles : acceptedFiles.split(",");
        var fileName_1 = file.name || "";
        var mimeType_1 = file.type || "";
        var baseMimeType_1 = mimeType_1.replace(/\/.*$/, "");
        return acceptedFilesArray.some(function (type) {
            var validType = type.trim();
            if (validType.charAt(0) === ".") {
                return endsWith(fileName_1.toLowerCase(), validType.toLowerCase());
            }
            else if (/\/\*$/.test(validType)) {
                // This is something like a image/* mime type
                return baseMimeType_1 === validType.replace(/\/.*$/, "");
            }
            return mimeType_1 === validType;
        });
    }
    return true;
}
export function getValue(data, args) {
    if (typeof data === "function") {
        return data.apply(void 0, args);
    }
    else {
        return data;
    }
}
var now = +new Date();
var index = 0;
export function createUid() {
    return "upload-" + now + "-" + ++index;
}
/**
 * 获取扩展名
 * @param url
 */
export function extname(url) {
    if (!url) {
        return "";
    }
    var temp = url.split("/");
    var filename = temp[temp.length - 1];
    var filenameWithoutSuffix = filename.split(/\?/)[0];
    return (/\.[^./\\]*$/.exec(filenameWithoutSuffix) || [""])[0];
}
/**
 * 是否图片
 * @param url
 */
export function isImageUrl(url) {
    var extension = extname(url);
    if (/^data:image\//.test(url) || /(webp|svg|png|gif|jpg|jpeg|bmp)$/i.test(extension)) {
        return true;
    }
    else if (/^data:/.test(url)) {
        // other file types of base64
        return false;
    }
    else if (extension) {
        // other file types which have extension
        return false;
    }
    return false;
}
//# sourceMappingURL=utils.js.map